/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : Main program body.
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/

/*
 *@Note
 USART Print debugging routine:
 USART1_Tx(PA9).
 This example demonstrates using USART1(PA9) as a print debug port output.

*/

#include "debug.h"
#include  "gpio.h"
#include "TM1637.h"
/* Global typedef */

/* Global define */

/* Global Variable */
u16 i=0;

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	Delay_Init();
	GPIO_SETUP();
	TM1637_Init();

	while(1)
    {

	  for (i = 0; i<= 1000;  i++) {
	          TM1637_DisplayDecimal(i, 0, ENABLE_ZEROS); // 0: OFF 1: ON ,if you write DISABLE_ZEROS then xxx0...xx10...x100...1000
	          Delay_Ms(1000);
	       }
	}
}

